package omo3;

import java.util.Objects;

/*
 *   Jednosmerny spojovy seznam
 */

public class LinkedList {

    // atributy tridy
    private Node head;

    // konstruktor
    public LinkedList() {
        head = null;
    }

    // prida prvek na konec seznamu
    public void addValue(Integer data) {
        if (isEmpty()) {
            head = new Node(data);
        } else {
            Node tmp = new Node(data);
            Node tmp2 = head;
            while (tmp2.getNext() != null) {
                tmp2 = tmp2.getNext();
            }
            tmp2.setNext(tmp);
        }
    }

    /*
     *   Odstrani prvek dane hodnoty ze seznamu.
     *   - pokud prvek v seznamu neni vrati FALSE
     *   - pokud byl prvek smazan vrati TRUE
     */
    public boolean remove(Integer data) {
        return false;
    }

    /*
     *   Odstrani prvek ze seznamu na zadanem indexu.
     *   pokud index je mimo vrati false
     */
    public boolean removeFromIndex(int index) {
        return false;
    }

    // Smaze vsechny prvky seznamu
    public void clear() {

    }

    // Vrati pocet prvku v seznamu
    public int size() {
        if (isEmpty()) {
            return 0;
        } else {
            int size = 1;
            Node tmp2 = head;
            while (tmp2.getNext() != null) {
                tmp2 = tmp2.getNext();
                size++;
            }
            return size;
        }
    }

        // TRUE - seznam je prazdny
    // FALSE - jinak
    public boolean isEmpty() {
        return head==null;
    }

    /*
     *   Vypise obsah seznamu v nasledujicim formatu
     *   - LIST[N] = {hodnota1, hodnota2, ... hodnotaN}, kde N je pocet prvku seznamu
     */
    @Override
    public String toString() {
        return null;
    }

    // Vrati data ulozena v Node na zadanem indexu
    // - indexujeme od 0
    public Integer getData(int index) {
        if (index<0){return -1;}
        int counter = 0;
        if(this.isEmpty()) {return -1;};
        Node temp = head;
        while(counter != index){
          
            temp = temp.getNext();
            if(temp==null){return -1;}
            counter++;
        }
        return temp.getData();
    }

    // Zmeni data na indexu
    // - pokud Node s indexem neexistuje vraci FALSE
    // - jina TRUE
    public boolean setData(int index, Integer data) {
        return false;
    }

    /*  
     *   Obsahuje seznam hodnotu urcenou parametrem ?
     *   TRUE - obsahuje
     *   FALSE - neobsahuje
     */
    public boolean contains(Integer data) {
        
        if(this.isEmpty())
            return false;
        Node tmp2 = head;
            while (tmp2 !=null) {
                if(Objects.equals(tmp2.getData(), data)){
                     return true;
                }
                tmp2=tmp2.getNext();
            }
        
        return false;
    }

    /*
     *   Vlozi novy prvek na pozici urcenou indexm
     *    - vraci FALSE pokud je index mimo rozsah  (index < 0 || index > size())
     *    - jinak TRUE
     * 
     *   poz.: Metoda musi prvek pridat, nikoliv prepsat
     */
    public boolean insert(int index, Integer data) {
        return false;
    }

}
