package omo3;

/*
 *   Node pro jednosmerny spojovy seznam
 */

public class Node {

    private Integer data;
    private Node next;

    // konstructor 1
    public Node(Integer data) {
        this.data = data;
        this.next = null;
    }

    // konstructor 2
    public Node(Integer data, Node node) {
        this.data = data;
        next = node;
    }


    // vrátí uložená data v Node
    public Integer getData() {
        return data;
    }

    // nastaví data do Node
    public void setData(Integer data) {
        this.data = data;
    }

    // vrati ukazatel na dalsi prvek
    public Node getNext() {
        return next;
    }
    // nastavi ukazatel na dalsi prvek
    public void setNext(Node next) {
        this.next = next;
    }

}